#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>

#include "mt19937ar.c"

int		ttm1, ttm2;

unsigned long init[4]={0x123, 0x456, 0x789, 0x012}, length=4;
int	p1,p2,p3,p4;

unsigned long genrand_int32(void);
void init_by_array(unsigned long *, int );

/******************************/

#define  jLoop  60
#define  iLoop  100000000

int main( )
{
	int	i;
	int	j;
	unsigned int  ret;

	double		dd;

	//	()
	init_by_array(init, length);

	ttm2= clock();
	while( ttm2==(ttm1=clock()) );

	ret= 0;
	for( j=jLoop;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			genrand_int32();
		}
	}

	ttm2= clock();
	dd= ( ttm2-ttm1 )/(double)CLOCKS_PER_SEC;

	ret= genrand_int32();
	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , 1.0*(double)iLoop*(double)jLoop/dd);

	//-----------------------------------------------------------------

	init_by_array(init, length);

	ttm2= clock();
	while( ttm2==(ttm1=clock()) );

	ret= 0;
	for( j=jLoop;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			genrand_int32();
		}
	}

	ttm2= clock();
	dd= ( ttm2-ttm1 )/(double)CLOCKS_PER_SEC;

	ret= genrand_int32();
	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , 1.0*(double)iLoop*(double)jLoop/dd);

	//-------------------------------------

	init_by_array(init, length);

	ttm2= clock();
	while( ttm2==(ttm1=clock()) );

	ret= 0;
	for( j=jLoop/4;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			genrand_int32();
			genrand_int32();
			genrand_int32();
			genrand_int32();
		}
	}

	ttm2= clock();
	dd= ( ttm2-ttm1 )/(double)CLOCKS_PER_SEC;

	ret= genrand_int32();
	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , (double)iLoop*(double)jLoop/dd);

	//-------------------------------------
	init_by_array(init, length);

	ttm2= clock();
	while( ttm2==(ttm1=clock()) );

	ret= 0;
	for( j=jLoop/4;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			genrand_int32();
			genrand_int32();
			genrand_int32();
			genrand_int32();
		}
	}

	ttm2= clock();
	dd= ( ttm2-ttm1 )/(double)CLOCKS_PER_SEC;

	ret= genrand_int32();
	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , (double)iLoop*(double)jLoop/dd);

	return(0);
}
