/*

200	0.99542544586
220	0.94488241639
240	0.74151655335
260	0.40150591119
280	0.13521534346
300	0.02772752291
320	0.00353432825
340	0.00029012484
360	0.00001593427
380	0.00000060725
400	0.00000001660

*/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>

#include "mt19937ar.c"

double		dIN[20]= {
	0.00457455414137142,	// 0-200		0
	0.05054302946725640,	// 200-220		1
	0.20336586303903600,	// 220-240		2
	0.34001064215954600,	// 240-260		3
	0.26629056773102100,	// 260-280		4
	0.10748782055623300,	// 280-300		5
	0.02419319465660970,	// 300-320		6
	0.00324420341002431,	// 320-340		7
	0.00027419056575577,	// 340-360		8
	0.00001532701853395,	// 360-380		9
	0.00000059065458737,	// 380-400		10
	0.00000001626473632,	// 400-420		11
	0.00000000033015165,	// 420-440		12
	0.00000000000513710,	// 440-			13
};

unsigned long	init[4], length;

int main(void)
{
	FILE	*out;
	char	FileName[]= "Kai-mt-3.xls";

	int i,j,k;
	int  box[256];

	unsigned int		p1,p2,p3,p4;
	p1= p2= p3= p4= 0;

	int		ic[20]; //200,	ic220,	ic240, ic260, ic280;
	//	int		ic300,	ic320,	ic340, ic360, ic380, ic400;

	double	t0,t1,t2;

	t0= (double)clock();

	//	()
	{
		init[0]= p1 += time( NULL );
		init[1]= p2 += clock();
		init_by_array(init, length);

		init[0]= p1+=  genrand_int32();
		init[1]= p2+=  genrand_int32();
		init[2]= p3+=  genrand_int32();
		init[3]= p4+=  genrand_int32();
		init_by_array(init, length);
	}

	init_by_array(init, length);

	for( i=0;i<20;i++ ) ic[i]= 0;
	int	in= 0;
	double	sum;

	t1= (double)clock();

	for( k=0;k<100;k++ ){
		//	()
		{
			init[0]= p1 += genrand_int32() + clock();
			init[1]= p2 += genrand_int32() + clock();
			init[2]= p3 += genrand_int32() + clock();
			init[3]= p4 += genrand_int32() + clock();
			init_by_array(init, length);
		}

		for( j=5000 ;j>0;j--){

			for( i=255;i>=0;i-- ) box[i]=0;

#define  loop 256*1000

			for (i = loop ; i >0 ; i--){
				unsigned int  irand;

				irand= genrand_int32();

				box[ (irand      & 0xff)]++;
				box[ (irand>>8)  & 0xff ]++;
				box[ (irand>>16) & 0xff ]++;
				box[ (irand>>24) & 0xff ]++;
			}

			{
				double	dd;
				int	i;
				sum= 0.0;

				for( i=0;i<256;i++){
					dd=(double)(box[ i ]-(loop*4/256) );
					sum += dd*dd;
				}
				sum /= (double)(loop*4/256);
			}

			{
				in += 1;
				/*
				int	icnt;
				icnt= (int)(( sum-180.0 )/20.0 );
				if( icnt < 0  ) icnt= 0;
				if( icnt > 13 ) icnt= 13; // ȂĂǂƂ͎vBBB
				ic[ icnt ]++;
				*/
				if     ( sum < 200.0 ) ic[0]++;
				else if( sum < 220.0 ) ic[1]++; // [200-220)
				else if( sum < 240.0 ) ic[2]++;
				else if( sum < 260.0 ) ic[3]++;
				else if( sum < 280.0 ) ic[4]++;
				else if( sum < 300.0 ) ic[5]++;
				else if( sum < 320.0 ) ic[6]++;
				else if( sum < 340.0 ) ic[7]++;
				else if( sum < 360.0 ) ic[8]++;
				else if( sum < 380.0 ) ic[9]++;
				else if( sum < 400.0 ) ic[10]++;
				else if( sum < 420.0 ) ic[11]++;
				else if( sum < 440.0 ) ic[12]++;
				else if( sum >= 440.0 ) ic[13]++;

			}

		} // for( j )
	}	// k

	t2= (double)clock();

	out = fopen( FileName , "at");
	{
		int	ii;
		double	sum= 0.0;
		//			for( ii=11;ii>0;ii-- ) ic[ii-1] += ic[ii];

		for( ii=0;ii<14;ii++ ){
			double	dd,dd2;
			dd2= dIN[ii]*(double)in;
			dd= ( dd2 - ic[ii]);
			sum += dd= dd*dd/dd2;
			printf("%20.5f\t%10d\t%20.10f\n", dd2, ic[ii], dd );
			fprintf( out, "%20.5f\t%10d\t%20.10f\n", dd2, ic[ii], dd );
		}
		printf("ChiSq=\t%20.5f\n",sum );
		fprintf( out, "ChiSq=\t%20.5f\n",sum );
	}
	printf(" %.3f sec\n",  (t2-t1)/(double)CLOCKS_PER_SEC );
	fprintf( out, " %.3f sec\n",  (t2-t1)/(double)CLOCKS_PER_SEC );

	fflush( out );
	fclose( out );

	return( 0 );
}
