/*

*/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>

#define		size	256

static	 unsigned int MT_x=123456789,MT_y=362436069,MT_z=521288629,MT_w=88675123;

inline  static	unsigned int MT_xor128(){
	unsigned int t;
	t=(MT_x^(MT_x<<11));
	MT_x=MT_y;
	MT_y=MT_z;
	MT_z=MT_w;
	return( MT_w=(MT_w^(MT_w>>19))^(t^(t>>8)) );
}

//#####

void	MT_xor_init( unsigned int p ){
	int	ii;
	MT_x=123456789,MT_y=362436069,MT_z=521288629,MT_w=88675123;
	MT_x += p++;
	MT_y += (p<<1)^(p>>1); p++;
	MT_z += (p<<2)^(p>>2); p++;
	MT_w += (p<<3)^(p>>3); p++;
	for( ii= 8; ii>0; ii-- ) MT_xor128();
}

int main(void)
{
	//	FILE	*out;

	int i,j,k;
	int  box[size][size];

	//	int		th= 10;

	unsigned int		p1,p2,p3,p4;
	p1= p2= p3= p4= 0;

	int		ic[20];

	double	t0,t1,t2;

	t0= (double)clock();

	//	()
	{
		p1= time( NULL );
		while( p1 == time( NULL ) );
		p1 += clock() + time( NULL );
		MT_xor_init(p1);
	}

	for( i=0;i<20;i++ ) ic[i]= 0;
	int	in= 0;
	double	sum;

	double	sum2= 0.0;
	//	double	dd2= 0.0;

	t1= (double)clock();

	for( k=0;k<500;k++ ){

		//	()
		{
			p1 += MT_xor128() + clock() + time( NULL );
			MT_xor_init(p1);
		}

		sum2= 0.0;
		in = 0;

		for( j=1000 ;j>0;j--){
			{
				int	ii, jj;
				for( ii=0;ii<size;ii++ ){
					for( jj=0;jj<size;jj++ ){
						box[ii][jj]=0;
					}
				}
			}

#define  loop size*size*100

			for (i = loop ; i > 0 ; i--){
				unsigned int  irand;

				irand= MT_xor128();

				box[ (irand      & 0xff)][ (irand>>24) & 0xff ]++;
			}

			{
				double	dd;
				int		ii,jj;

				sum= 0.0;

				for( ii=0;ii<size;ii++ ){
					for( jj=0;jj<size;jj++ ){
						dd= (double)( box[ii][jj] - (loop/(size*size) ) );
						sum += dd*dd;
					}
				}

				sum /= (double)(loop/(size*size) );

			}

			in += 1;
			sum2 += sum;

		} // for( j )

		t2= (double)clock();

		printf(" n= %5d Average= %f\t", in, sum2/(double)in );
		printf("\t%x,%x,%x,%x\n",p1,p2,p3,p4);

	}	// k

	return( 0 );
}
