#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>

#include "mt19937ar.c"

int		tm1, tm2;

unsigned long genrand_int32(void);
void init_by_array(unsigned long *, int );

unsigned int p1=10,p2=20,p3=30,p4=40;
unsigned long init[4]={0x123, 0x456, 0x789, 0xabc}, length=4;
/******************************/

#define  jLoop  (1<<10)	// (1<<10)
#define  iLoop  (1<<28) // 268435456

int	main( int argc, char *argv[] )
{
	int	iMask= 0x1 ;
	int	k;

	clock();

	{
		if( argc==2 ){
			k=  atoi( argv[1] );
			if( k<0 || k>=32 ){
				printf("program.exe xx ( 0 to 31 )\n");
				return( -1 );
			}
		}
		else{
				printf("program.exe xx ( 0 to 31 )\n");
			return( -1 );
		}
	}
	iMask<<=k;

	int	i;
	int	j;
	int  ret, ret1,  count= 0;
	//	int	ii;

	unsigned int		iData0[64], iData00[64];
	unsigned int		iData1[64], iData11[64];

	for( i=0;i<64;i++ )	iData0[i]= 0;
	for( i=0;i<64;i++ )	iData00[i]= 0;
	for( i=0;i<64;i++ )	iData1[i]= 0;
	for( i=0;i<64;i++ )	iData11[i]= 0;

	//	()
	{
		init[0] += time( NULL );
		init[1] += clock();
		init_by_array(init, length);

		p1= init[0] +=  genrand_int32();
		p2= init[1] +=  genrand_int32();
		p3= init[2] +=  genrand_int32();
		p4= init[3] +=  genrand_int32();
		init_by_array(init, length);
		printf("%x %x %x %x\n",p1,p2,p3,p4);
	}

	tm2= clock();
	while( tm2==(tm1=clock()) );

	ret= genrand_int32() & iMask;

	count=1;
	for( j=jLoop;j>0;j--){
		if( (j % 50)==0 ) printf("%d,",j);
		for (i = iLoop; i >0 ; i--) {
			if( ret == (ret1= genrand_int32() & iMask) ){
				count++;
			}else{
				if( count>63 ) count= 63;

				if( ret == 0 ){
					if( ++iData0[ count ] >= 100000000 ){
						iData00[ count ]++;
						iData0[ count ]= 0;
					}
				}else{
					if( ++iData1[ count ] >= 100000000 ){
						iData11[ count ]++;
						iData1[ count ]= 0;
					}
				}
				count= 1;
				ret= ret1;
			}
		}
	}
	double	d2=1.0/8.0;
	for( i=1;i<23;i++, d2 /= 2.0 ){
		double	dd;
		dd= ( (double)jLoop*(double)iLoop)*d2;
		printf("%d\t%16.3f\t%16.0f\t%16.0f\n",i,
		dd,
		( (double)iData00[i]*1e8+(double)iData0[i] ),
		( (double)iData11[i]*1e8+(double)iData1[i] ) );
	}

	tm2= clock();

	{
		FILE	*fp;
		int	i; //,ii;

		char	ch[32]= "resultMT";
		char	ch2[8]= "xx.txt";

		ch2[0]= '0' + ( k/10 );
		ch2[1]= '0' + ( k%10 );

		strcat( ch, ch2 );

		if (( fp = fopen( ch , "at")) == NULL)
		{
			fprintf(stderr, "o̓t@CJ܂\n");
			return 1;
		}

		fprintf( fp,"%x %x %x %x\n",p1,p2,p3,p4);
		{
			double	d2=1.0/8.0;
			double	d0, d1;
			double	dSum0= 0.0, dSum1=0.0;

			for( i=1;i<64;i++, d2 /= 2.0 ){
				double	dd;
				dd= ( (double)jLoop*(double)iLoop)*d2;
				fprintf( fp,"%d\t%16.5f\t%16.0f\t%16.0f\n",i,
				dd,
				d0= ( (double)iData00[i]*1e8+(double)iData0[i] ),
				d1= ( (double)iData11[i]*1e8+(double)iData1[i] )  );
				if( i<=30 ){
					dSum0 += (d0-dd)*(d0-dd)/dd;
					dSum1 += (d1-dd)*(d1-dd)/dd;
				}
			}
			fprintf( fp, "KaiSq= 0:%.3f, 1:%.3f, Sum:%.3f\n", dSum0, dSum1, dSum0+dSum1 );
		}

		{
			double dd;
			dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC;
			fprintf(fp , "Mask= %x\n", iMask );
			fprintf(fp , "%8.3f sec\t%.3e count/sec\n", dd , (double)iLoop*(double)jLoop/dd);
			fclose( fp );

			printf("%8.3f sec\t%.3e count/sec", dd , (double)iLoop*(double)jLoop/dd);
		}
	}

	//-----------------------------------------------------------------
	return( 0 );
}
