#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>

#include <time.h>

static	 unsigned int MT_x=123456789,MT_y=362436069,MT_z=521288629,MT_w=88675123;

inline  static	unsigned int MT_xor128(){
	unsigned int t;
	t=(MT_x^(MT_x<<11));
	MT_x=MT_y;
	MT_y=MT_z;
	MT_z=MT_w;
	return( MT_w=(MT_w^(MT_w>>19))^(t^(t>>8)) );
}

//#####

void	MT_xor_init( unsigned int p ){
	int	ii;
	MT_x=123456789,MT_y=362436069,MT_z=521288629,MT_w=88675123;
	MT_x += p++;
	MT_y += (p<<1)^(p>>1); p++;
	MT_z += (p<<2)^(p>>2); p++;
	MT_w += (p<<3)^(p>>3); p++;
	for( ii= 8; ii>0; ii-- ) MT_xor128();
}

int		tm1, tm2; //,tm3;

//inline unsigned int	MT_rand32( void );
//void			MT_rr_init( unsigned long * );

/******************************/

#define  jLoop  60   // 12̔{
#define  iLoop  100000000

int main( )
{
	int	i;
	int	j;
	unsigned int	ret;
	unsigned int	p1;
	double			dd;

	clock();

	//	()
	p1= 100;
	MT_xor_init(p1);

	printf("%x\n",p1 );

	tm1= clock();

	ret= 0;
	for( j=jLoop;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			MT_xor128();
		}
	}

	tm2= clock();
	dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC;

	ret= MT_xor128();
	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , 1.0*(double)iLoop*(double)jLoop/dd);

	//-----------------------------------------------------------------

	p1= 100;
	MT_xor_init(p1);

	tm1= clock();

	ret= 0;
	for( j=jLoop;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			MT_xor128();
		}
	}

	tm2= clock();
	dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC;

	ret= MT_xor128();
	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , 1.0*(double)iLoop*(double)jLoop/dd);

	//-------------------------------------

	p1= 100;
	MT_xor_init(p1);

	tm1= clock();

	ret= 0;
	for( j=jLoop/4;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			MT_xor128();
			MT_xor128();
			MT_xor128();
			MT_xor128();
		}
	}

	tm2= clock();
	dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC;

	ret= MT_xor128();
	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , (double)iLoop*(double)jLoop/dd);

	//-------------------------------------
	p1= 100;
	MT_xor_init(p1);

	tm1= clock();

	ret= 0;
	for( j=jLoop/4;j>0;j--){
		for (i = iLoop; i >0 ; i--) {
			MT_xor128();
			MT_xor128();
			MT_xor128();
			MT_xor128();
		}
	}

	tm2= clock();
	dd= ( tm2-tm1 )/(double)CLOCKS_PER_SEC;

	ret= MT_xor128();
	printf("%8.3f sec\t%8x\t%.3e count/sec\n", dd , ret , (double)iLoop*(double)jLoop/dd);

	return( 0 );
}
